#!/bin/sh -e

CON_NAME=$(nmcli -t -f type,name c | awk -F: '$1 == "gsm" { print $2 }')
[ -n "$CON_NAME" ] || CON_NAME="$1"

if CON_INFO=$(nmcli con show "$CON_NAME" 2> /dev/null); then
	APN=$(echo "$CON_INFO" | awk '$1 == "gsm.apn:" { print $2 }')
	USER=$(echo "$CON_INFO" | awk '$1 == "gsm.username:" { print $2 }')
	MCCMNC=$(echo "$CON_INFO" | awk '$1 == "gsm.network-id:" { print $2 }')
	REFUSE_PAP=$(echo "$CON_INFO" | awk '$1 == "ppp.refuse-pap:" { print $2 }')

	if MODEM_INFO=$(mmcli -m 0 -K 2> /dev/null); then
		SIM=$(echo "$MODEM_INFO" | awk '$1 == "modem.generic.sim" { print $3 }' | rev | cut -d '/' -f 1 | rev)
		IMSI=$(mmcli -i "$SIM" -K 2> /dev/null | awk '$1 == "sim.properties.imsi" { print $3 }')
		SIGNALQ=$(echo "$MODEM_INFO" | awk '$1 == "modem.generic.signal-quality.value" { print $3 }')
	fi
	if [ -n "$APN" ]; then
		AUTH="CHAP"
	fi

	if [ "$REFUSE_PAP" = "no" ]; then
		AUTH="PAP"
	fi

	printf "%s" "$APN;$USER;$MCCMNC;$AUTH;$IMSI;$SIGNALQ"
fi
